#!/bin/sh
# the next line restarts using wish \
exec wish8.4 "$0" "$@"

# $Id: double.tcl,v 1.3 1998/03/12 03:52:31 brianp Exp $

# Togl - a Tk OpenGL widget
# Copyright (C) 1996  Brian Paul and Ben Bederson
# See the LICENSE file for copyright details.


# $Log: double.tcl,v $
# Revision 1.3  1998/03/12 03:52:31  brianp
# now sharing display lists between the widgets
#
# Revision 1.2  1996/10/23 23:31:56  brianp
# added -ident options to togl calls
#
# Revision 1.1  1996/10/23 23:17:22  brianp
# Initial revision
#


# An Tk/OpenGL widget demo with two windows, one single buffered and the
# other double buffered.

load ./cube[info sharedlibextension]

proc setup {} {
	wm title . "OpenGL using Tcl/Tk"

	# create a frame widget
   frame .f1

   # create first Togl widget
   togl .f1.o1 -width 400 -height 400  \
		-double true -depth true \
		-ident Cube::one

	# create scale and button widgets
   scale  .sx   -label {X Axis} -from 0 -to 360 -command {setAngle x} -orient horizontal
   scale  .sy   -label {Y Axis} -from 0 -to 360 -command {setAngle y} -orient horizontal
   button .btn  -text Quit -command {
		exit
	}

	# bind the motion event to the Togl widget
   bind .f1.o1 <B1-Motion> {
		motion_event [lindex [%W config -width] 4] \
		     [lindex [%W config -height] 4] \
		     %x %y
    }

    pack .f1.o1 -side left -padx 3 -pady 3 -fill both -expand t
    pack .f1  -fill both -expand t
    pack .sx  -fill x
    pack .sy  -fill x
    pack .btn -fill x
}


# This is called when mouse button 1 is pressed and moved in either of
# the OpenGL windows.
proc motion_event { width height x y } {
    .f1.o1 setXrot [expr 360.0 * $y / $height]
    .f1.o1 setYrot [expr 360.0 * ($width - $x) / $width]

    .sx set [getXrot]
    .sy set [getYrot]
}

# This is called when a slider is changed.
proc setAngle {axis value} {
   global xAngle yAngle zAngle

   switch -exact $axis {
	x {.f1.o1 setXrot $value}
	y {.f1.o1 setYrot $value}
   }
}

# Execution starts here!
setup
