#!/bin/sh
# the next line restarts using wish \
exec wish "$0" "$@"

load ./scanline[info sharedlibextension]

proc setup {} {
	wm title . "Scanline Demo"
	frame .f1
	# create first Togl widget
	togl .f1.o1 -width 500 -height 500  \
		-rgba true  -double true -depth true \
		-alpha true -accum true -time 50 -ident Scanline::One

	button .btn  -text Quit -command { exit }

	bind .f1.o1 <B1-Motion> { %W movePoints %x %y }
	
	bind .f1.o1 <Button-1> { %W selectPoints %x %y }

    pack .f1.o1 -side top -padx 3 -pady 3 -fill both -expand t
    pack .f1  -fill both -expand t
    pack .btn -fill x
}


# This is called when mouse button 1 is pressed and moved in 
# either of the OpenGL windows.
proc motion_event { x y } { %W movePoints $x $y }

# Execution starts here!
setup
