/*
 RECORD.EXE
 Copyright (c), Firelight Technologies Pty, Ltd, 2000-2004.

 Nearly all the code in this file was originally from the above applcations source code,
 but has been changed and adjusted by me to suit my purpose.


*/

#include "FMODmike.h"



/*
OSCILLOSCOPE CODE:  I include the following code as it compiles, and shows in esscence 
how to obtain values corresponding to the oscilloscope graph.  It doesnt work however. 
The problem lies when trying to obtain the values, thye all turn out the same.  Either 
I'm not reading them properly, something is set up slightly wrong.



FSOUND_DSPUNIT			*OscUnit = NULL; 	
static signed short		*OscBuffer = NULL;
static int				OscBlock = 0;




void * F_CALLBACKAPI OscCallback(void *originalbuffer, void *newbuffer, int length, void *userdata)
{
	int             mixertype = FSOUND_GetMixer();
    int             count;
	int             totalblocks; 
    signed short    *dest;

	totalblocks = FSOUND_DSP_GetBufferLengthTotal() / FSOUND_DSP_GetBufferLength(); 
	
    
     //   Convert and downmix into a mono short int buffer.
    

    dest = &OscBuffer[OscBlock * FSOUND_DSP_GetBufferLength()];

    if (mixertype == FSOUND_MIXER_QUALITY_FPU)
    {
        float *src = (float *)newbuffer;

        for (count=0; count < length; count++)
        {
            dest[count] = (signed short)((src[count << 1] + src[(count << 1) + 1]) * 0.5f);
        }
    }
    else if (mixertype == FSOUND_MIXER_MMXP5 || mixertype == FSOUND_MIXER_MMXP6 || mixertype == FSOUND_MIXER_QUALITY_MMXP5 || mixertype == FSOUND_MIXER_QUALITY_MMXP6)
    {
        signed short *src = (signed short *)newbuffer;

        for (count=0; count < length; count++)
        {
            dest[count] = (signed short)(((int)src[count << 1] + (int)src[(count << 1) + 1]) >> 1);
        }
    }
    else
    {
        signed int *src = (signed int *)newbuffer;

        for (count=0; count < length; count++)
        {
            dest[count] = (signed short)((src[count << 1] + src[(count << 1) + 1]) >> 1);
        }
    }

    OscBlock++;
    if (OscBlock >= totalblocks)
    {
        OscBlock = 0;
    }

	return newbuffer;
}



void initDSP()
{
	// Create buffer and dsp unit for oscilliscope.
	
	OscUnit	    = FSOUND_DSP_Create(&OscCallback, FSOUND_DSP_DEFAULTPRIORITY_USER+3,	0);
    OscBuffer   = new short[(FSOUND_DSP_GetBufferLengthTotal() + 16) * 2]; // *2 for mono 16bit buffer 
}



float* getOscYvalues()
{
	#define NUM_VALS 256	
	//return same number as spectrum
	float *yVal;
	yVal = new float[NUM_VALS];

	if (OscBuffer)
    {
        int count, offset; 
		float step, xoff;
        signed short *src;
        
           // The next pcmblock (Oscblock + 1) is the one that is audible.
        
        offset = (OscBlock + 1) * FSOUND_DSP_GetBufferLength();
        if (offset >= FSOUND_DSP_GetBufferLengthTotal())
        {
            offset -= FSOUND_DSP_GetBufferLengthTotal();
        }

        src = &OscBuffer[offset];

        
          //  xoff is the x position that is scaled lookup of the dsp block according to the size
          //  of the array.
               

        xoff = 0;
		step = (float)FSOUND_DSP_GetBufferLength() / NUM_VALS;
		
		
		
		for (count=0; count < NUM_VALS; count++)
        {
            int x; 

			x  = (int)xoff;
            yVal[count]  = (float)src[x];
			cout << yVal[count] << endl;
			

			xoff+=step;

        }
		cout<< endl;
    }

	return yVal;
   
}

*/


//-------------------------------------------------------
//c_driver class functions
//-------------------------------------------------------

c_driver::c_driver()
{
	sample = NULL;
	
}

int c_driver::loadDrivers()
{
	
	signed char key;
	int  i, driver;

	if (FSOUND_GetVersion() < FMOD_VERSION)
	{
		cout << "Error : You are using the wrong DLL version!  You should be using FMOD " << FMOD_VERSION <<endl;
		return 0;
	}

	/*
	    SELECT OUTPUT METHOD
	*/
	
    printf("---------------------------------------------------------\n");	
    printf("Output Type\n");	
    printf("---------------------------------------------------------\n");	
#if defined(WIN32) || defined(_WIN64) || defined(__CYGWIN32__) || defined(__WATCOMC__)
    printf("1 - Direct Sound\n");
    printf("2 - Windows Multimedia Waveout\n");
    printf("3 - NoSound\n");
#elif defined(__linux__)
    printf("1 - OSS - Open Sound System\n");
    printf("2 - ESD - Elightment Sound Daemon\n");
    printf("3 - ALSA 0.9 - Advanced Linux Sound Architecture\n");   
#endif
	printf("---------------------------------------------------------\n");	/* print driver names */
	printf("Press a corresponding number or ESC to quit\n");

	do
	{
		key = _getch();
	} while (key != 27 && key < '1' && key > '4');
	

	switch (key)
	{
#if defined(WIN32) || defined(_WIN64) || defined(__CYGWIN32__) || defined(__WATCOMC__)
		case '1' :	FSOUND_SetOutput(FSOUND_OUTPUT_DSOUND);
					break;
		case '2' :	FSOUND_SetOutput(FSOUND_OUTPUT_WINMM);
					break;
		case '3' :	FSOUND_SetOutput(FSOUND_OUTPUT_NOSOUND);
					break;
#elif defined(__linux__)
		case '1' :	FSOUND_SetOutput(FSOUND_OUTPUT_OSS);
					break;
		case '2' :	FSOUND_SetOutput(FSOUND_OUTPUT_ESD);
					break;
		case '3' :	FSOUND_SetOutput(FSOUND_OUTPUT_ALSA);
					break;
#endif
		default :	return 0;
	}
	
	/*
	    SELECT OUTPUT DRIVER
	*/

	/* The following list are the drivers for the output method selected above. */
    printf("---------------------------------------------------------\n");	
    switch (FSOUND_GetOutput())
    {
        case FSOUND_OUTPUT_NOSOUND:    printf("NoSound"); break;
        case FSOUND_OUTPUT_WINMM:      printf("Windows Multimedia Waveout"); break;
        case FSOUND_OUTPUT_DSOUND:     printf("Direct Sound"); break;
        case FSOUND_OUTPUT_OSS:        printf("Open Sound System"); break;
        case FSOUND_OUTPUT_ESD:        printf("Enlightment Sound Daemon"); break;
        case FSOUND_OUTPUT_ALSA:       printf("ALSA"); break;       
    };
	printf(" Driver list\n");	
	printf("---------------------------------------------------------\n");	

	for (i=0; i < FSOUND_GetNumDrivers(); i++) 
	{
		cout <<  FSOUND_GetDriverName(i) << endl;	/* print driver names */
	}
	printf("---------------------------------------------------------\n");	/* print driver names */
	printf("Press a corresponding number or ESC to quit\n");

	do
	{
		key = _getch();
		if (key == 27) 
		{
			FSOUND_Close();
			return 0;
		}
		driver = key - '1';
	} while (driver < 0 || driver >= FSOUND_GetNumDrivers());

	FSOUND_SetDriver(driver);					/* Select sound card (0 = default) */

	/*
	    SELECT MIXER
	*/

	FSOUND_SetMixer(FSOUND_MIXER_QUALITY_AUTODETECT);



		
	/*
	    INITIALIZE
	*/
	if (!FSOUND_Init(OUTPUTRATE, 64, FSOUND_INIT_ACCURATEVULEVELS))
	{
		printf("Error!\n");
		printf("%s\n", FMOD_ErrorString(FSOUND_GetError()));
		return 0;
	}

	//set FFT unit so spectrum analysis can be done
	FSOUND_DSP_SetActive(FSOUND_DSP_GetFFTUnit(), TRUE);
//	FSOUND_DSP_SetActive(OscUnit, TRUE);
	
	
	
	return 0;

}




int c_driver::loadDevice()
{
	/*
	    SELECT INPUT DRIVER (can be done before or after init)
	*/

	/* The following list are the drivers for the output method selected above. */
	printf("---------------------------------------------------------\n");	
	switch (FSOUND_GetOutput())
	{
        case FSOUND_OUTPUT_NOSOUND:    printf("NoSound"); break;
        case FSOUND_OUTPUT_WINMM:      printf("Windows Multimedia Waveout"); break;
        case FSOUND_OUTPUT_DSOUND:     printf("Direct Sound"); break;
        case FSOUND_OUTPUT_OSS:        printf("Open Sound System"); break;
        case FSOUND_OUTPUT_ESD:        printf("Enlightment Sound Daemon"); break;
        case FSOUND_OUTPUT_ALSA:       printf("ALSA"); break;       
	};
	printf(" Recording device driver list\n");	
	printf("---------------------------------------------------------\n");	

	for (int i=0; i < FSOUND_Record_GetNumDrivers(); i++) 
	{
		printf("%d - %s\n", i+1, FSOUND_Record_GetDriverName(i));	/* print driver names */
	}
	printf("---------------------------------------------------------\n");	/* print driver names */
	printf("Press a corresponding number or ESC to quit\n");

	do
	{
		int key = _getch();
		if (key == 27) 
			return 0;
		outDriver = key - '1';
	} while (outDriver < 0 || outDriver >= FSOUND_Record_GetNumDrivers());

	/*MOVED
	if (!FSOUND_Record_SetDriver(outDriver))	// Select input sound card (0 = default) 
	{
		printf("Error!\n");
		printf("%s\n", FMOD_ErrorString(FSOUND_GetError()));
		FSOUND_Close();
		return 0;
	}*/
	
	/*
	    DISPLAY HELP
	*/

	printf("FSOUND Output Method : ");
	switch (FSOUND_GetOutput())
	{
        case FSOUND_OUTPUT_NOSOUND:    printf("FSOUND_OUTPUT_NOSOUND\n"); break;
        case FSOUND_OUTPUT_WINMM:      printf("FSOUND_OUTPUT_WINMM\n"); break;
        case FSOUND_OUTPUT_DSOUND:     printf("FSOUND_OUTPUT_DSOUND\n"); break;
        case FSOUND_OUTPUT_OSS:        printf("FSOUND_OUTPUT_OSS\n"); break;
        case FSOUND_OUTPUT_ESD:        printf("FSOUND_OUTPUT_ESD\n"); break;
        case FSOUND_OUTPUT_ALSA:       printf("FSOUND_OUTPUT_ALSA\n"); break;       
	};

	printf("FSOUND Mixer         : ");
	switch (FSOUND_GetMixer())
	{
		case FSOUND_MIXER_BLENDMODE:	printf("FSOUND_MIXER_BLENDMODE\n"); break;
		case FSOUND_MIXER_MMXP5:		printf("FSOUND_MIXER_MMXP5\n"); break;
		case FSOUND_MIXER_MMXP6:		printf("FSOUND_MIXER_MMXP6\n"); break;
		case FSOUND_MIXER_QUALITY_FPU:	printf("FSOUND_MIXER_QUALITY_FPU\n"); break;
		case FSOUND_MIXER_QUALITY_MMXP5:printf("FSOUND_MIXER_QUALITY_MMXP5\n"); break;
		case FSOUND_MIXER_QUALITY_MMXP6:printf("FSOUND_MIXER_QUALITY_MMXP6\n"); break;
	};
	printf("FSOUND Driver        : %s\n", FSOUND_GetDriverName(FSOUND_GetDriver()));
	printf("FSOUND Record Driver : %s\n", FSOUND_Record_GetDriverName(FSOUND_Record_GetDriver()));



	/*
	    REALTIME FULL DUPLEX RECORD / PLAYBACK!
	*/

	if (FSOUND_GetOutput() == FSOUND_OUTPUT_OSS)
    {
	    sample = FSOUND_Sample_Alloc(FSOUND_UNMANAGED, RECORDLEN, FSOUND_MONO | FSOUND_8BITS | FSOUND_UNSIGNED, RECORDRATE, 255, 128, 255);
    }
    else
    {
        sample = FSOUND_Sample_Alloc(FSOUND_UNMANAGED, RECORDLEN, FSOUND_STEREO | FSOUND_16BITS , RECORDRATE, 255, 128, 255);
	}

	
	/*
	OscUnit	    = FSOUND_DSP_Create(&OscCallback, FSOUND_DSP_DEFAULTPRIORITY_USER+3,	0);
    OscBuffer   = calloc(FSOUND_DSP_GetBufferLengthTotal() + 16, 2); // *2 for mono 16bit buffer 
	
	//set oscilloscope dsp unit
	FSOUND_DSP_SetActive(OscUnit, TRUE);
	*/
	


	
	return 0;
}

int c_driver::setDevice()
{
	if (!FSOUND_Record_SetDriver(outDriver))	// Select input sound card (0 = default) 
	{
		printf("Error!\n");
		printf("%s\n", FMOD_ErrorString(FSOUND_GetError()));
		FSOUND_Close();
		return 0;
	}

	return 0;
}


int c_driver::startRecord()
{
	
	
	/*
	printf("\n=========================================================================\n");
	printf("Press a key to start device\n");
	printf("=========================================================================\n");

	_getch();
*/
	FSOUND_Sample_SetMode(sample, FSOUND_LOOP_NORMAL);	/* make it a looping sample */

	if (!FSOUND_Record_StartSample(sample, TRUE))	/* start recording and make it loop also */
	{
		printf("Error!\n");
		printf("%s\n", FMOD_ErrorString(FSOUND_GetError()));

		FSOUND_Close();
		return 0;
	}

    /*
        Increase this value if the sound sounds corrupted or the time between recording
        and hearing the result is longer than it should be..
    */
    #define RECORD_DELAY_MS       20
    #define RECORD_DELAY_SAMPLES  (RECORDRATE * RECORD_DELAY_MS / 1000)

    /*
        Let the record cursor move forward a little bit first before we try to play it
        (the position jumps in blocks, so any non 0 value will mean 1 block has been recorded)
    */
    while (!FSOUND_Record_GetPosition()) 
    {
        Sleep(1);
    }

	channel = FSOUND_PlaySound(FSOUND_FREE, sample);

	originalfreq = FSOUND_GetFrequency(channel);

		
/*	printf("initial delay = %d\n", FSOUND_GetCurrentPosition(channel) - FSOUND_Record_GetPosition()); */
	return 0;
}



void c_driver::runDevice()
{		
	
		int playpos, recordpos, diff;
		static int oldrecordpos = 0, oldplaypos = 0;

		playpos = FSOUND_GetCurrentPosition(channel);
		recordpos = FSOUND_Record_GetPosition();

		/* 
            NOTE : As the recording and playback frequencies arent guarranteed to be exactly in 
		    sync, we have to adjust the playback frequency to keep the 2 cursors just enough 
		    apart not to overlap. (and sound corrupted)
		    This code tries to keep it inside a reasonable size window just behind the record
		    cursor. ie [........|play window|<-delay->|<-Record cursor.............] 
        */

		/*
            Dont do this code if either of the cursors just wrapped
        */
		if (playpos > oldplaypos && recordpos > oldrecordpos)	
		{
			diff = playpos - recordpos;

			if (diff > -RECORD_DELAY_SAMPLES)
            {
				FSOUND_SetFrequency(channel, originalfreq - 1000);	/* slow it down */
				//cout << "slowed down" << endl;
            }
			else if (diff < -(RECORD_DELAY_SAMPLES * 2))
            {
				FSOUND_SetFrequency(channel, originalfreq + 1000);	/* speed it up */
				//cout << "sped up"  << endl;
            }
			else
            {
				FSOUND_SetFrequency(channel, originalfreq);	

            }
		}

		oldplaypos = playpos;
		oldrecordpos = recordpos;

		
		
		spectrum = FSOUND_DSP_GetSpectrum();    /* returns an array of 512 floats */

		//osc = getOscYvalues();

		

		//Sleep(10);
}

int c_driver::closeDevice()
{

    _getch();

	FSOUND_StopSound(channel);
	FSOUND_Record_Stop();

	/*
	    CLEANUP AND SHUTDOWN
	*/

    FSOUND_Sample_Free(sample);
    FSOUND_Close();
    return 0;
}


void c_driver::doVu(int channel)
{
	/*
    Print some info and a VU meter (vu is smoothed)
    */

	
	float vuval, l, r;
	

	FSOUND_GetCurrentLevels(channel, &l, &r);
    vuval = (l+r) * 0.5f;
    vuval *= 18.0f;

	

	#define VUSPEED 0.6f

	if (vuval > smoothedVu)
    {
		smoothedVu = vuval;
    }

	smoothedVu -= VUSPEED;
	if (smoothedVu < 0)
    {
		smoothedVu = 0;
    }


}


void c_driver::printVu()
{
	char vu[19];
	
	cout << smoothedVu << " ";

	memset(vu, 0, 19);
	memset(vu, '=', (int)(smoothedVu));

	printf(" VU:%-15s\r", vu);
}


	

float c_driver::getVu()
{
	return smoothedVu;
}

	


int c_driver::getChannel()
{
	return channel;
}



float c_driver::getSpectrumVal(int i)
{
	return spectrum[i];
}

/*
float c_driver::getOscVal(int i)
{
	return osc[i];
}
*/




	



		


