
#ifndef _FMODMIKE_GUARD
#define _FMODMIKE_GUARD

/*
 RECORD.EXE
 Copyright (c), Firelight Technologies Pty, Ltd, 2000-2004.

*/

#include <stdio.h>
#include <stdlib.h>

#if defined(WIN32) || defined(__WATCOMC__) || defined(_WIN32) || defined(__WIN32__)
    #include <conio.h>
    #include <windows.h>
    #define __PACKED /*dummy*/
#else
    #include "../../api/inc/wincompat.h"
    #include <string.h>
    #define __PACKED __attribute__((packed)) /* gcc packed */
#endif

#include <iostream>
#include "FMOD\\fmod.h"
#include "FMOD\\fmod_errors.h"	/* optional */

#define RECORDRATE      44100
#define RECORDLEN       (RECORDRATE * 5)    /* 5 seconds at RECORDRATE khz */
#define OUTPUTRATE      44100


//following written by myself....

using namespace std;

class c_driver
{
private:
	//driver stuff
	FSOUND_SAMPLE  *sample;
	int outDriver;
	int channel;
	int originalfreq;

	//levels value
	float smoothedVu;

	//ffp spectrum values
	float *spectrum;

	//oscilloscope Y values
	//float *osc;
	

	
	

public:
	c_driver();
	int loadDrivers();
	int loadDevice();
	int setDevice();
	int startRecord();
	void runDevice();
	int closeDevice();
	
	void doVu(int);
	float getVu();
	void printVu();

	float getSpectrumVal(int);
	//float getOscVal(int);

	int getChannel();	

};

/*
These functions were supposed set a DSP unit and return an array of floats corresponding to the Y value in the oscilloscope graph 


void * F_CALLBACKAPI OscCallback(void *originalbuffer, void *newbuffer, int length, void *userdata);
void initDSP();
float* getOscYvalues();
*/

#endif