#ifndef _MLCODE
#define _MLCODE

#include <iostream>
#include <ML/ml.h>
#include <ML/mlu.h>
#include <vector>
#include <string>

using namespace std;


class c_parameter
{
private:
	MLint64 paramId;
	MLint64 deviceId;
	MLpv* paramName;

public:
	c_parameter();
	c_parameter(MLint64 i_paramId,MLint64 i_deviceId);
	void setParameter(MLint64 i_paramId,MLint64 i_deviceId);
	void printParameter();

};

class c_params
{
private:
	unsigned int numParams;
	MLpv*				paramIds;
	MLpv*				pathName;
	MLint64				pathId;	
	MLint64				deviceId;

protected:
	


public:
	vector<c_parameter> parameter;

	c_params();
	c_params(MLint64 i_pathId);
	void loadParams(MLint64 i_pathId);
	void printNumParams();
	void printPathName();
	unsigned int getNumParams();
	MLint64 getParamId(unsigned int paramNo);
	



};

class c_paths
{
private:
	unsigned int	 numPaths;
	MLpv*			 pathIds;
	MLint64			 deviceId;
	MLpv*			 deviceName;
	

protected:
	


public:
	vector<c_params> paramIds;

	c_paths();
	c_paths(MLint64 i_deviceId);
	void loadPaths(MLint64 i_deviceId);
	void printNumPaths();
	void printDevice();
	MLint64 getPathId(unsigned int pathNo);
	MLint32 getPathBufferAlignment(unsigned int pathNo);
	unsigned int getNumPaths();

	

};

class c_jackName
{
private:
	MLint64 jackId;
	MLpv* jackName;

public:
	c_jackName();
	c_jackName(MLint64 i_jackId);
	void printJackName();
};

class c_jacks
{
private:
	unsigned int numJacks;
	MLpv*		 jackIds;
	MLint64		 deviceId;
	vector<c_jackName> names;

public:
	c_jacks();
	c_jacks(MLint64 i_deviceId);
};






class c_devices
{
private:
	
	unsigned int	numDevices;
	MLpv*			deviceIds;
	

protected:
	
	

public:
	
	c_devices();
	void loadDevices();
	void printNumDevices();
	void printAll();
	MLint64 getDeviceId(unsigned int deviceNo);
	unsigned int getNumDevices();

	vector<c_paths> paths;
	vector<c_jacks> jacks;

	
};






#endif